## osgearth 2.9.0+dfsg

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11 FATAL_ERROR)

if(COMMAND cmake_policy)
    # Works around warnings libraries linked against that don't
    # have absolute paths (e.g. -lpthreads)
    cmake_policy(SET CMP0003 NEW)

    # Works around warnings about escaped quotes in ADD_DEFINITIONS
    # statements.
    cmake_policy(SET CMP0005 OLD)
    
    # Qt5 qt5_use_modules usage was causing "Policy CMP0043 is not set: Ignore COMPILE_DEFINITIONS_<Config> properties." warnings
    cmake_policy(SET CMP0043 NEW)

endif(COMMAND cmake_policy)

#
# Set up CMake to use Solution Folders in VS.
#
SET_PROPERTY( GLOBAL PROPERTY USE_FOLDERS               ON )
SET_PROPERTY( GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMake Targets" )

PROJECT(OSGEARTH)

SET(OSGEARTH_MAJOR_VERSION 2)
SET(OSGEARTH_MINOR_VERSION 9)
SET(OSGEARTH_PATCH_VERSION 0)
SET(OSGEARTH_SOVERSION     0)

SET(OSGEARTH_PLUGIN_PREFIX "")

IF (CYGWIN)
    SET(OSGEARTH_PLUGIN_PREFIX "cygwin_")
ENDIF()

IF(MINGW)
    SET(OSGEARTH_PLUGIN_PREFIX "mingw_")
ENDIF()


SET(OSGEARTH_VERSION ${OSGEARTH_MAJOR_VERSION}.${OSGEARTH_MINOR_VERSION}.${OSGEARTH_PATCH_VERSION})


# We want to build SONAMES shared librariess
SET(OSGEARTH_SONAMES TRUE)
SET(OPENTHREADS_SONAMES TRUE)

SET(OpenThreads_SOURCE_DIR ${OSGEARTH_SOURCE_DIR})

# Good place to look for the OSG 3rd party libs
SET(THIRD_PARTY_DIR "" CACHE PATH "OSG 3rd-party dependency folder")

# We have some custom .cmake scripts not in the official distribution.
# Maybe this can be used override existing behavior if needed?
SET(CMAKE_MODULE_PATH "${OSGEARTH_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")

# Attempt to detect the GIT revision number.
OPTION(OSGEARTH_EMBED_GIT_SHA "Embeds the GIT SHA in the version code" OFF)
IF (OSGEARTH_EMBED_GIT_SHA)
  include(GetGitRevisionDescription)
  get_git_head_revision(GIT_REFSPEC OSGEARTH_GIT_SHA1)
ENDIF (OSGEARTH_EMBED_GIT_SHA)

#
SET(OSGEARTH_USE_GLES FALSE)

# check for iOS build
OPTION(OSGEARTH_BUILD_PLATFORM_IPHONE "Enable IPhoneSDK Device support" OFF)
OPTION(OSGEARTH_BUILD_PLATFORM_IPHONE_SIMULATOR "Enable IPhoneSDK Simulator support" OFF)

IF(OSGEARTH_BUILD_PLATFORM_IPHONE OR OSGEARTH_BUILD_PLATFORM_IPHONE_SIMULATOR)
    SET(OSGEARTH_USE_GLES TRUE)
    #you need to manually set the default sdk version here
    SET (IPHONE_SDKVER "10.2" CACHE STRING "iOS SDK-Version")
    SET (IPHONE_VERSION_MIN "8.0" CACHE STRING "IOS minimum os version, use 7.0 or greater to get 64bit support")
    SET (IPHONE_PLATFORMSROOT "/Applications/Xcode.app/Contents/Developer/Platforms")

    IF(OSGEARTH_BUILD_PLATFORM_IPHONE)
        SET(CMAKE_OSX_SYSROOT "${IPHONE_PLATFORMSROOT}/iPhoneOS.platform/Developer/SDKs/iPhoneOS${IPHONE_SDKVER}.sdk" CACHE STRING "System root for iOS" FORCE)
        SET(CMAKE_OSX_ARCHITECTURES "armv7;armv7s;arm64" CACHE STRING "Build architectures for iOS" FORCE)
    ELSE()
        SET(CMAKE_OSX_SYSROOT "${IPHONE_PLATFORMSROOT}/iPhoneSimulator.platform/Developer/SDKs/iPhoneSimulator${IPHONE_SDKVER}.sdk" CACHE STRING "System root for iOS" FORCE)
        SET(CMAKE_OSX_ARCHITECTURES "i386" CACHE STRING "Build architectures for iOS Simulator" FORCE)
    ENDIF()
ENDIF ()


# check if STLport is required
OPTION(USE_STLPORT "Set to ON to build OSGEARTH with stlport instead of the default STL library." OFF)
IF(USE_STLPORT)
	INCLUDE_DIRECTORIES(${STLPORT_DIR}/stlport)
	LINK_DIRECTORIES(${STLPORT_DIR}/lib)
ENDIF()

# Okay, here's the problem: On some platforms, linking against OpenThreads
# is not enough and explicit linking to the underlying thread library
# is also required (e.g. FreeBSD). But OpenThreads may be built with different
# backends (Pthreads, Sproc, Windows) so we don't know what the underlying
# thread library is because some platforms support multiple backends (e.g.
# IRIX supports Sproc and Pthreads). Linking all libraries won't work
# because the libraries may be incompatible.
# So the current solution is to attempt best guess linking and exempt certain
# cases. With IRIX, we're going to hope explicit linking to the underlying
# library is not necessary. We currently don't case for pthreads on Windows
# which might be an issue on things like Cygwin. This may need to be fixed.
FIND_PACKAGE(Threads)
IF(CMAKE_SYSTEM MATCHES IRIX)
    # Erase CMAKE_THREAD_LIBS_INIT and hope it works
    SET(CMAKE_THREAD_LIBS_INIT "" CACHE INTERNAL "")
ENDIF(CMAKE_SYSTEM MATCHES IRIX)

IF (OSGEARTH_USE_GLES)
    FIND_PACKAGE(OpenGLES) 
ELSE ()
    FIND_PACKAGE(OpenGL)
ENDIF (OSGEARTH_USE_GLES)

FIND_PACKAGE(CURL)
FIND_PACKAGE(GDAL)
FIND_PACKAGE(GEOS)
FIND_PACKAGE(Sqlite3)
FIND_PACKAGE(ZLIB)
FIND_PACKAGE(Poco)

FIND_PACKAGE(LevelDB)
FIND_PACKAGE(RocksDB)

FIND_PACKAGE(SilverLining QUIET)
FIND_PACKAGE(Triton QUIET)

FIND_PACKAGE(PROTOBUF QUIET)

SET (WITH_EXTERNAL_DUKTAPE FALSE CACHE BOOL "Use bundled or system wide version of Duktape")
IF (WITH_EXTERNAL_DUKTAPE)
    FIND_PACKAGE(Duktape)
ENDIF (WITH_EXTERNAL_DUKTAPE)

# option to install shaders:
OPTION(OSGEARTH_INSTALL_SHADERS "Whether to deploy GLSL shaders when doing a Make INSTALL" OFF)

SET (WITH_EXTERNAL_TINYXML FALSE CACHE BOOL "Use bundled or system wide version of TinyXML")
IF (WITH_EXTERNAL_TINYXML)
    FIND_PACKAGE(TinyXML)
ENDIF (WITH_EXTERNAL_TINYXML)

IF(UNIX)
    # Not sure what this will do on Cygwin and Msys
    # Also, remember OS X X11 is a user installed option so it may not exist.
    FIND_PACKAGE(X11)
    # Some Unicies need explicit linkage to the Math library or the build fails.
    FIND_LIBRARY(MATH_LIBRARY m)
ENDIF(UNIX)


OPTION(OSGEARTH_QT_BUILD "Enable to use Qt (build Qt-dependent libraries, plugins and examples)" OFF)
OPTION(OSGEARTH_QT_BUILD_LEGACY_WIDGETS "Build the legacy Qt widgets" OFF)
set(OSGEARTH_QT_VERSION 5 CACHE STRING "Qt version to use")

IF(OSGEARTH_QT_BUILD)
  # To select a specific version of QT define DESIRED_QT_VERSION
  # via cmake -DDESIRED_QT_VERSION=5
  # QUIET option disables messages if the package cannot be found.
  IF  (OSGEARTH_QT_VERSION)
      IF  (OSGEARTH_QT_VERSION MATCHES "5")
          FIND_PACKAGE(Qt5Widgets REQUIRED)
      ELSEIF (OSGEARTH_QT_VERSION MATCHES "4")
          FIND_PACKAGE(Qt4 REQUIRED)
      ENDIF()
  ELSE()
      FIND_PACKAGE(Qt5Widgets QUIET)
      IF ( NOT Qt5Widgets_FOUND )
          FIND_PACKAGE(Qt4 REQUIRED)
      ENDIF()
  ENDIF()
ENDIF(OSGEARTH_QT_BUILD)

IF(Qt5Widgets_FOUND)
  message(STATUS "Qt: Using version 5")
  FIND_PACKAGE(Qt5Core QUIET)
  FIND_PACKAGE(Qt5Gui QUIET)
  FIND_PACKAGE(Qt5OpenGL QUIET)
  FIND_PACKAGE(Qt5OpenGLExtensions QUIET)
  IF ( Qt5Core_FOUND AND Qt5Widgets_FOUND AND Qt5Gui_FOUND AND Qt5OpenGL_FOUND AND Qt5OpenGLExtensions_FOUND )
    SET(QT_INCLUDES ${Qt5Widgets_INCLUDE_DIRS} ${Qt5OpenGL_INCLUDE_DIRS} ${Qt5OpenGLExtensions_INCLUDE_DIRS})
  ENDIF ()
ELSEIF(QT4_FOUND)
  message(STATUS "Qt: Using version 4")
  INCLUDE(${QT_USE_FILE})
  SET(QT_INCLUDES ${QT_INCLUDES} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR}${QT_QTOPENGL_INCLUDE_DIR} )
  SET(QT_ALL_LIBRARIES ${QT_LIBRARIES} ${QT_QTCORE_LIBRARY} ${QT_QTWEBKIT_LIBRARY} ${QT_QTNETWORK_LIBRARY} ${QT_QTXML_LIBRARY} ${QT_QTOPENGL_LIBRARY})
ENDIF ()


# Common global definitions
#ADD_DEFINITIONS(-D)
# Platform specific definitions


IF(WIN32)
  FIND_PACKAGE(GLCORE)
  IF(GLCORE_FOUND)
      INCLUDE_DIRECTORIES( ${GLCORE_INCLUDE_DIR} )
  ENDIF()    

  IF(MSVC)
        # This option is to enable the /MP switch for Visual Studio 2005 and above compilers
        OPTION(WIN32_USE_MP "Set to ON to build osgEarth with the /MP option (Visual Studio 2005 and above)." OFF)
        MARK_AS_ADVANCED(WIN32_USE_MP)
        IF(WIN32_USE_MP)
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
        ENDIF(WIN32_USE_MP)

        # turn off various warnings
        # foreach(warning 4244 4251 4267 4275 4290 4786 4305 4996)
        #     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd${warning}")
        # endforeach(warning)

        # More MSVC specific compilation flags
        ADD_DEFINITIONS(-D_SCL_SECURE_NO_WARNINGS)
        ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
    ENDIF(MSVC)
ENDIF(WIN32)

# Common to all platforms:

SET(CMAKE_DEBUG_POSTFIX  "d" CACHE STRING "add a postfix, usually d on windows")
SET(CMAKE_RELEASE_POSTFIX "" CACHE STRING "add a postfix, usually empty on windows")
SET(CMAKE_RELWITHDEBINFO_POSTFIX "rd" CACHE STRING "add a postfix, usually empty on windows")
SET(CMAKE_MINSIZEREL_POSTFIX "s" CACHE STRING "add a postfix, usually empty on windows")

INCLUDE(OsgEarthMacroUtils)

DETECT_OSG_VERSION()

IF (NOT OPENSCENEGRAPH_VERSION)
	SET(OPENSCENEGRAPH_VERSION ${OPENSCENEGRAPH_MAJOR_VERSION}.${OPENSCENEGRAPH_MINOR_VERSION}.${OPENSCENEGRAPH_PATCH_VERSION})
ENDIF(NOT OPENSCENEGRAPH_VERSION)

FIND_PACKAGE(OSG)

# Make the headers visible to everything
INCLUDE_DIRECTORIES(
    ${OSGEARTH_SOURCE_DIR}/src
    ${OSG_INCLUDE_DIR}
)

#FIND_PACKAGE(GDAL)

################################################################################
# Create bin and lib directories if required

IF("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
   FILE(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/bin ${CMAKE_BINARY_DIR}/lib)
ENDIF("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")


################################################################################
# Installation stuff


IF(UNIX AND NOT WIN32 AND NOT APPLE)
  IF(CMAKE_SIZEOF_VOID_P MATCHES "8")
      SET(LIB_POSTFIX "64" CACHE STRING "suffix for 32/64 dir placement")
      MARK_AS_ADVANCED(LIB_POSTFIX)
  ENDIF(CMAKE_SIZEOF_VOID_P MATCHES "8")
ENDIF(UNIX AND NOT WIN32 AND NOT APPLE)
IF(NOT DEFINED LIB_POSTFIX)
    SET(LIB_POSTFIX "")
ENDIF(NOT DEFINED LIB_POSTFIX)

#SET(OUTPUT_BINDIR ${PROJECT_BINARY_DIR}/bin/${CMAKE_SYSTEM_NAME})
SET(OUTPUT_BINDIR ${PROJECT_BINARY_DIR}/bin)
MAKE_DIRECTORY(${OUTPUT_BINDIR})
SET(EXECUTABLE_OUTPUT_PATH ${OUTPUT_BINDIR})

#SET(OUTPUT_LIBDIR ${PROJECT_BINARY_DIR}/lib/${CMAKE_SYSTEM_NAME})
SET(OUTPUT_LIBDIR ${PROJECT_BINARY_DIR}/lib)
MAKE_DIRECTORY(${OUTPUT_LIBDIR})
SET(LIBRARY_OUTPUT_PATH ${OUTPUT_LIBDIR})

LINK_DIRECTORIES( ${LINK_DIRECTORIES} ${OUTPUT_LIBDIR} )


################################################################################
# User Options


# Expose CMAKE_INCLUDE_PATH and CMAKE_LIBARY_PATH to the GUI so users
# may set these values without needing to manipulate the environment.
SET(CMAKE_INCLUDE_PATH ${CMAKE_INCLUDE_PATH} CACHE STRING "You may add additional search paths here. Use ; to separate multiple paths.")
SET(CMAKE_LIBRARY_PATH ${CMAKE_LIBRARY_PATH} CACHE STRING "You may add additional search paths here. Use ; to separate multiple paths.")
# We are proposing that a new variable called CMAKE_PREFIX_PATH be introduced
# to CMake to compliment CMAKE_INCLUDE_PATH and CMAKE_LIBRARY_PATH.
# A formal feature request has been submited to CMake, Bug #4947.
# It is intended for those users who have common prefixes for their INCLUDE
# and LIBRARY locations. So if users have headers in /usr/local/include
# and libraries in /usr/local/lib, the common prefix is /usr/local.
# It should also cover the case where headers and libraries are
# in the same directory.
# Our proposal expects that FIND_* commands will automatically search for
# CMAKE_PREFIX_PATH right after CMAKE_INCLUDE_PATH or CMAKE_LIBRARY_PATH.
# Obviously, since CMake does not currently support this, we must write
# our Find*.cmake modules to explicitly support this. Otherwise, this variable
# will have no impact.
# This is unofficial so this may be removed or changed at anytime.
SET(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} CACHE STRING "(EXPERIMENTAL) You may add additional search paths here. Use ; to separate multiple paths.")

# Dynamic vs Static Linking
OPTION(DYNAMIC_OSGEARTH "Set to ON to build OSGEARTH for dynamic linking.  Use OFF for static." ON)
IF   (DYNAMIC_OSGEARTH)
    SET(OSGEARTH_USER_DEFINED_DYNAMIC_OR_STATIC "SHARED")
ELSE (DYNAMIC_OSGEARTH)
    SET(OSGEARTH_USER_DEFINED_DYNAMIC_OR_STATIC "STATIC")
ENDIF(DYNAMIC_OSGEARTH)

=== docs/CMakeLists.txt ===
### DOCUMENTATION ###

set( DOCS_ROOT
    source/about.rst
    source/data.rst
    source/faq.rst
    source/howtos.rst
    source/index.rst
    source/install.rst
    source/ios.rst
    source/releasenotes.rst
    source/startup.rst
)

set( DOCS_DEVELOPER
    source/developer/coordinate_systems.rst
    source/developer/custom_driver.rst
    source/developer/index.rst
    source/developer/maps.rst
    source/developer/qt_integration.rst
    source/developer/shader_composition.rst
    source/developer/utilities.rst
)

set( DOCS_REFERENCES
    source/references/colorfilters.rst
    source/references/earthfile.rst
    source/references/envvars.rst
    source/references/index.rst
    source/references/symbology.rst
)

set( DOCS_REFRENCES_DRIVERS
    source/references/drivers/index.rst
)

set( DOCS_REFERENCES_DRIVERS_FEATURE
    source/references/drivers/feature/index.rst
    source/references/drivers/feature/ogr.rst
    source/references/drivers/feature/tfs.rst
    source/references/drivers/feature/wfs.rst
)

set( DOCS_REFERENCES_DRIVERS_LOADERS
    source/references/drivers/loaders/index.rst
)

set( DOCS_REFERENCES_DRIVERS_MODEL
    source/references/drivers/model/feature_geom.rst
    source/references/drivers/model/feature_model_shared_blocks.rst
    source/references/drivers/model/feature_model_shared_props.rst
    source/references/drivers/model/index.rst
    source/references/drivers/model/simple.rst
)

set( DOCS_REFERENCES_DRIVERS_TERRAIN
    source/references/drivers/terrain/index.rst
    source/references/drivers/terrain/mp.rst
    source/references/drivers/terrain/terrain_options_shared.rst
)

set( DOCS_REFERENCES_DRIVERS_TILE
    source/references/drivers/tile/agglite.rst
    source/references/drivers/tile/arcgis.rst
    source/references/drivers/tile/debug.rst
    source/references/drivers/tile/gdal.rst
    source/references/drivers/tile/index.rst
    source/references/drivers/tile/noise.rst
    source/references/drivers/tile/osg.rst
    source/references/drivers/tile/tilecache.rst
    source/references/drivers/tile/tileservice.rst
    source/references/drivers/tile/tms.rst
    source/references/drivers/tile/vpb.rst
    source/references/drivers/tile/wcs.rst
    source/references/drivers/tile/wms.rst
    source/references/drivers/tile/xyz.rst
)

set( DOCS_USER
    source/user/annotations.rst
    source/user/caching.rst
    source/user/earthfiles.rst
    source/user/elevation.rst
    source/user/features.rst
    source/user/imagery.rst
    source/user/index.rst
    source/user/maps.rst
    source/user/profile.rst
    source/user/spatialreference.rst
    source/user/tools.rst
)

source_group( Developer                    FILES ${DOCS_DEVELOPER} )
source_group( References                   FILES ${DOCS_REFERENCES} )
source_group( References\\Drivers          FILES ${DOCS_REFERENCES_DRIVERS} )
source_group( References\\Drivers\\Feature FILES ${DOCS_REFERENCES_DRIVERS_FEATURE} )
source_group( References\\Drivers\\Loaders FILES ${DOCS_REFERENCES_DRIVERS_LOADERS} )
source_group( References\\Drivers\\Model   FILES ${DOCS_REFERENCES_DRIVERS_MODEL} )
source_group( References\\Drivers\\Terrain FILES ${DOCS_REFERENCES_DRIVERS_TERRAIN} )
source_group( References\\Drivers\\Tile    FILES ${DOCS_REFERENCES_DRIVERS_TILE} )
source_group( User                         FILES ${DOCS_USER} )

add_custom_target( 
    Documentation
    SOURCES
        ${DOCS_ROOT}
        ${DOCS_DEVELOPER}
        ${DOCS_REFERENCES}
        ${DOCS_REFERENCES_DRIVERS}
        ${DOCS_REFERENCES_DRIVERS_FEATURE}
        ${DOCS_REFERENCES_DRIVERS_LOADERS}
        ${DOCS_REFERENCES_DRIVERS_MODEL}
        ${DOCS_REFERENCES_DRIVERS_TERRAIN}
        ${DOCS_REFERENCES_DRIVERS_TILE}
        ${DOCS_USER}
)

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/osgEarth.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/osgEarth.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/osgEarth"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/osgEarth"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== src/CMakeLists.txt ===
#the old construct SUBDIRS( was substituded by ADD_SUBDIRECTORY that is to be preferred according on CMake docs.
FOREACH( lib
         osgEarth
         osgEarthAnnotation
         osgEarthFeatures
         osgEarthSymbology
         osgEarthUtil )

    ADD_SUBDIRECTORY(${lib})

    SET_PROPERTY(TARGET ${lib} PROPERTY FOLDER "Core")

ENDFOREACH( lib )


FOREACH( lib
         osgEarthQt
         osgEarthSplat
         osgEarthSilverLining
         osgEarthTriton )
    add_subdirectory( ${lib} )
ENDFOREACH( lib )

ADD_SUBDIRECTORY( osgEarthDrivers )

IF(NOT ANDROID)
    ADD_SUBDIRECTORY( applications )
ENDIF()

IF(NOT OSGEARTH_BUILD_PLATFORM_IPHONE AND NOT OSGEARTH_BUILD_PLATFORM_IPHONE_SIMULATOR)
    ADD_SUBDIRECTORY( tests )
ENDIF()


IF(MSVC80)
  OPTION(OSGEARTH_MSVC_GENERATE_PLUGINS_AND_WRAPPERS_MANIFESTS "Generate or not manifests files under VS8 for dynamically loaded dlls" ON)
ENDIF(MSVC80)

=== src/applications/CMakeLists.txt ===
PROJECT(OSGEARTH_APPLICATIONS)

SET(OSGCORE_BUNDLED TRUE)

IF(NOT OSGCORE_BUNDLED)
	FIND_PACKAGE(OSGCORE)
	IF(OSGCORE_FOUND)
		INCLUDE(${OSGCORE_USE_FILE})
	ELSE(OSGCORE_FOUND)
		MESSAGE(ERROR "OSGCORE neeeded but NOT FOUND")
	ENDIF(OSGCORE_FOUND)
	SET(CMAKE_MODULE_PATH  ${PROJECT_SOURCE_DIR}/../../Macros)
ENDIF(NOT OSGCORE_BUNDLED)
SET(OPENSCENEGRAPH_APPLICATION_DIR ${PROJECT_SOURCE_DIR})


#OpenThreads, osg, osgDB and osgUtil are included elsewhere.
SET(TARGET_COMMON_LIBRARIES
    osgEarth
    osgEarthFeatures
    osgEarthUtil
    osgEarthSymbology
    osgEarthAnnotation
)

SET(TARGET_DEFAULT_PREFIX "application_")
SET(TARGET_DEFAULT_APPLICATION_FOLDER "Applications")

SET(TARGET_DEFAULT_LABEL_PREFIX "Tool")
SET(TARGET_DEFAULT_APPLICATION_FOLDER "Tools")

IF(NOT OSGEARTH_BUILD_PLATFORM_IPHONE AND NOT OSGEARTH_BUILD_PLATFORM_IPHONE_SIMULATOR)

ADD_SUBDIRECTORY(osgearth_viewer)
ADD_SUBDIRECTORY(osgearth_seed)
ADD_SUBDIRECTORY(osgearth_package)
ADD_SUBDIRECTORY(osgearth_tfs)
ADD_SUBDIRECTORY(osgearth_boundarygen)
ADD_SUBDIRECTORY(osgearth_overlayviewer)
ADD_SUBDIRECTORY(osgearth_version)
ADD_SUBDIRECTORY(osgearth_tileindex)
ADD_SUBDIRECTORY(osgearth_atlas)
ADD_SUBDIRECTORY(osgearth_conv)
ADD_SUBDIRECTORY(osgearth_3pv)

IF (Qt5Widgets_FOUND OR QT4_FOUND AND NOT ANDROID AND OSGEARTH_QT_BUILD AND OSGEARTH_QT_BUILD_LEGACY_WIDGETS)
    ADD_SUBDIRECTORY(osgearth_package_qt)
ENDIF()

IF(BUILD_OSGEARTH_EXAMPLES)
    SET(TARGET_DEFAULT_LABEL_PREFIX "Sample")
    SET(TARGET_DEFAULT_APPLICATION_FOLDER "Samples")
    ADD_SUBDIRECTORY(osgearth_manip)
    ADD_SUBDIRECTORY(osgearth_toc)
    ADD_SUBDIRECTORY(osgearth_elevation)
    ADD_SUBDIRECTORY(osgearth_features)
    ADD_SUBDIRECTORY(osgearth_featureinfo)
    ADD_SUBDIRECTORY(osgearth_featurefilter)
    ADD_SUBDIRECTORY(osgearth_los)
    ADD_SUBDIRECTORY(osgearth_terrainprofile)
    ADD_SUBDIRECTORY(osgearth_map)
    ADD_SUBDIRECTORY(osgearth_annotation)
    ADD_SUBDIRECTORY(osgearth_tracks)
    ADD_SUBDIRECTORY(osgearth_transform)
    ADD_SUBDIRECTORY(osgearth_horizon)
    ADD_SUBDIRECTORY(osgearth_http)
    ADD_SUBDIRECTORY(osgearth_measure)
    ADD_SUBDIRECTORY(osgearth_controls)
    ADD_SUBDIRECTORY(osgearth_shadercomp)
    ADD_SUBDIRECTORY(osgearth_tilesource)
    ADD_SUBDIRECTORY(osgearth_imageoverlay)
    ADD_SUBDIRECTORY(osgearth_city)
    ADD_SUBDIRECTORY(osgearth_graticule)
    ADD_SUBDIRECTORY(osgearth_featurequery)
    ADD_SUBDIRECTORY(osgearth_occlusionculling)
    ADD_SUBDIRECTORY(osgearth_colorfilter)
    ADD_SUBDIRECTORY(osgearth_sequencecontrol)
    ADD_SUBDIRECTORY(osgearth_minimap)
    ADD_SUBDIRECTORY(osgearth_mrt)
    ADD_SUBDIRECTORY(osgearth_shadergen)
    ADD_SUBDIRECTORY(osgearth_clipplane)
    ADD_SUBDIRECTORY(osgearth_cache_test)
    ADD_SUBDIRECTORY(osgearth_pick)
    ADD_SUBDIRECTORY(osgearth_wfs)
    ADD_SUBDIRECTORY(osgearth_datetime)
    ADD_SUBDIRECTORY(osgearth_ephemeris)
    ADD_SUBDIRECTORY(osgearth_computerangecallback)
    ADD_SUBDIRECTORY(osgearth_skyview)
    ADD_SUBDIRECTORY(osgearth_server)
    ADD_SUBDIRECTORY(osgearth_srstest)
    ADD_SUBDIRECTORY(osgearth_lights)
    ADD_SUBDIRECTORY(osgearth_noisegen)
    ADD_SUBDIRECTORY(osgearth_infinitescroll)
    ADD_SUBDIRECTORY(osgearth_video)
    ADD_SUBDIRECTORY(osgearth_splat)
    ADD_SUBDIRECTORY(osgearth_htm)

    IF (Qt5Widgets_FOUND OR QT4_FOUND AND NOT ANDROID AND OSGEARTH_QT_BUILD)
        ADD_SUBDIRECTORY(osgearth_qt_simple)
        ADD_SUBDIRECTORY(osgearth_qt_windows)
    ENDIF()

    IF(SILVERLINING_FOUND)
        ADD_SUBDIRECTORY(osgearth_silverlining)
    ENDIF(SILVERLINING_FOUND)

    IF(TRITON_FOUND)
        ADD_SUBDIRECTORY(osgearth_triton)
    ENDIF(TRITON_FOUND)

ENDIF(BUILD_OSGEARTH_EXAMPLES)

ELSE()

    IF(BUILD_OSGEARTH_EXAMPLES)
        SET(TARGET_DEFAULT_LABEL_PREFIX "Sample")
        SET(TARGET_DEFAULT_APPLICATION_FOLDER "Samples")
        ADD_SUBDIRECTORY(osgearth_viewerIOS)
    ENDIF()

ENDIF()

=== src/osgEarth/CMakeLists.txt ===
IF   (DYNAMIC_OSGEARTH)
    ADD_DEFINITIONS(-DOSGEARTH_LIBRARY)
ELSE (DYNAMIC_OSGEARTH)
    ADD_DEFINITIONS(-DOSGEARTH_LIBRARY_STATIC)
ENDIF(DYNAMIC_OSGEARTH)

# CURL options
OPTION(CURL_IS_STATIC "on if curl is a static lib " ON)
MARK_AS_ADVANCED(CURL_IS_STATIC)

# NVTT mipmap generation 
option(OSGEARTH_ENABLE_NVTT_CPU_MIPMAPS "Use NVTT, if available, to generate texture mipmaps on the CPU" OFF)
mark_as_advanced(OSGEARTH_ENABLE_NVTT_CPU_MIPMAPS)
if(OSGEARTH_ENABLE_NVTT_CPU_MIPMAPS)
    add_definitions(-DOSGEARTH_ENABLE_NVTT_CPU_MIPMAPS)
endif(OSGEARTH_ENABLE_NVTT_CPU_MIPMAPS)

# TinyXML options
ADD_DEFINITIONS(-DTIXML_USE_STL)

# Builds the HTTPClient with WIN_INET instead of CURL
OPTION(OSGEARTH_USE_WININET_FOR_HTTP "Whether to use the WinInet library for HTTP requests (instead of cURL)" OFF)
if (OSGEARTH_USE_WININET_FOR_HTTP)
    ADD_DEFINITIONS(-DOSGEARTH_USE_WININET_FOR_HTTP)
endif (OSGEARTH_USE_WININET_FOR_HTTP)

IF(WIN32)
    IF(MSVC)
        SET(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:MSVCRT")
    ENDIF(MSVC)
    IF(CURL_IS_STATIC)
        ADD_DEFINITIONS(-DCURL_STATICLIB)
        SET(TARGET_EXTERNAL_LIBRARIES ws2_32 winmm wldap32)
    ENDIF(CURL_IS_STATIC)
    LIST(APPEND TARGET_EXTERNAL_LIBRARIES psapi)
ENDIF(WIN32)

SET(LIB_NAME osgEarth)

set(TARGET_GLSL
    DepthOffset.vert.glsl
    Draping.vert.glsl
    Draping.frag.glsl
    GPUClamping.vert.glsl
    GPUClamping.vert.lib.glsl
    GPUClamping.frag.glsl
    Instancing.vert.glsl
    PhongLighting.vert.glsl
    PhongLighting.frag.glsl)

set(SHADERS_CPP "${CMAKE_CURRENT_BINARY_DIR}/AutoGenShaders.cpp")

set(TARGET_IN
    Shaders.cpp.in)

configure_shaders(
    Shaders.cpp.in
    ${SHADERS_CPP}
    ${TARGET_GLSL} )

SET(HEADER_PATH ${OSGEARTH_SOURCE_DIR}/include/${LIB_NAME})

SET(LIB_PUBLIC_HEADERS
    Bounds
    Cache
    CacheEstimator
    CacheBin
    CachePolicy
    CacheSeed
    Capabilities
    Clamping
    ClampableNode
    ClampingTechnique
    ColorFilter
    Common
    CompositeTileSource
    Config
    Containers
    Cube
    CullingUtils
    DateTime
    DateTimeRange
    DepthOffset
    DrapeableNode
    DrapingCullSet
    DrapingTechnique
    DrawInstanced
    ECEF
    ElevationLayer
    ElevationLOD
    ElevationPool
    ElevationQuery
    Endian
    Export
    Extension
    FadeEffect
    FileUtils
    GeoCommon
    GeoData
    Geoid
    GeoMath
    GeoTransform
    GeometryClamper
    GLSLChunker
    HeightFieldUtils
    Horizon
    HTTPClient
    ImageLayer
    ImageMosaic
    ImageToHeightFieldConverter
    ImageUtils
    IntersectionPicker
    IOTypes
    JsonUtils
    LandCover
    LandCoverLayer
    Layer
    LayerListener
    Lighting
    LineFunctor
    Locators
    LocalTangentPlane
    Map
    MapCallback
    MapFrame
    MapInfo
    MapModelChange
    MapNode
    MapNodeObserver
    MapNodeOptions
    MapOptions
    MaskLayer
    MaskNode
    MaskSource
    Memory
    MemCache
    MetaTile
    Metrics
    ModelLayer
    ModelSource
    NativeProgramAdapter
    NodeUtils
    Notify
    optional
    ObjectIndex
    OverlayDecorator
    PagedNode
    PatchLayer
    PhongLightingEffect
    Picker
    PluginLoader
    PrimitiveIntersector
    Profile
    Profiler
    Progress
    Random
    Registry
    ResourceReleaser
    Revisioning
    SceneGraphCallback
    ScreenSpaceLayout
    Shaders
    ShaderFactory
    ShaderGenerator
    ShaderLoader
    ShaderUtils
    Shadowing
    SharedSARepo
    SimplexNoise
    SpatialReference
    StateSetCache
    StateSetLOD
    Status
    StringUtils
    TaskService
    Terrain
    TerrainEffect
    TerrainLayer
    TerrainOptions
    TerrainEngineNode
    TerrainEngineRequirements
    TerrainResources
    TerrainTileModel
    TerrainTileModelFactory
    TerrainTileNode
    TileKeyDataStore
    Tessellator
    TileKey
    TileHandler
    TileRasterizer
    TileSource
    TileVisitor
    TimeControl
    TraversalData
    ThreadingUtils
    Units
    URI
    Utils
    Version
    VerticalDatum
    VideoLayer
    Viewpoint
    VirtualProgram
    VisibleLayer
    WrapperLayer
    XmlUtils
)


IF (NOT TINYXML_FOUND)
    SET(LIB_PUBLIC_HEADERS
        ${LIB_PUBLIC_HEADERS}
        tinystr.h
        tinyxml.h
    )
ENDIF (NOT TINYXML_FOUND)

IF (NOT TINYXML_FOUND)
    SET(TINYXML_SRC
        tinystr.cpp
        tinyxml.cpp
        tinyxmlerror.cpp
        tinyxmlparser.cpp
    )
ENDIF (NOT TINYXML_FOUND)


SET(VERSION_GIT_SOURCE "")
IF (OSGEARTH_EMBED_GIT_SHA)
	ADD_DEFINITIONS(-DOSGEARTH_EMBED_GIT_SHA)

	# auto-generate the VersionGit file to include the git SHA1 variable.
	configure_file(
		"${CMAKE_CURRENT_SOURCE_DIR}/VersionGit.cpp.in"
		"${CMAKE_CURRENT_BINARY_DIR}/VersionGit.cpp"
		@ONLY)

	set(VERSION_GIT_SOURCE "${CMAKE_CURRENT_BINARY_DIR}/VersionGit.cpp")
ENDIF (OSGEARTH_EMBED_GIT_SHA)

set(TARGET_SRC
    Bounds.cpp
    Cache.cpp
    CacheBin.cpp
    CacheEstimator.cpp
    CachePolicy.cpp
    CacheSeed.cpp
    Capabilities.cpp
    Clamping.cpp
    ClampableNode.cpp
    ClampingTechnique.cpp
    ColorFilter.cpp
    CompositeTileSource.cpp
    Config.cpp
    Cube.cpp
    CullingUtils.cpp
    DateTime.cpp
    DateTimeRange.cpp
    DepthOffset.cpp
    DrapeableNode.cpp
    DrapingCullSet.cpp
    DrapingTechnique.cpp
    DrawInstanced.cpp
    ECEF.cpp
    ElevationLayer.cpp
    ElevationLOD.cpp
    ElevationPool.cpp
    ElevationQuery.cpp
    Extension.cpp
    FadeEffect.cpp
    FileUtils.cpp
    GeoData.cpp
    Geoid.cpp
    GeoMath.cpp
    GeoTransform.cpp
    GeometryClamper.cpp
    GLSLChunker.cpp
    HeightFieldUtils.cpp
    Horizon.cpp
    HTTPClient.cpp
    ImageLayer.cpp
    ImageMosaic.cpp
    ImageToHeightFieldConverter.cpp
    ImageUtils.cpp
    IntersectionPicker.cpp
    IOTypes.cpp
    JsonUtils.cpp
    LandCover.cpp
    LandCoverLayer.cpp
    Layer.cpp
    Lighting.cpp
    Locators.cpp
    LocalTangentPlane.cpp
    Map.cpp
    MapCallback.cpp
    MapFrame.cpp
    MapInfo.cpp
    MapNode.cpp
    MapNodeOptions.cpp
    MapOptions.cpp
    MaskLayer.cpp
    MaskNode.cpp
    MaskSource.cpp
    MemCache.cpp
    Memory.cpp
    MetaTile.cpp
    Metrics.cpp
    MimeTypes.cpp
    ModelLayer.cpp
    ModelSource.cpp
    NodeUtils.cpp
    Notify.cpp
    ObjectIndex.cpp
    OverlayDecorator.cpp
    PagedNode.cpp
    PatchLayer.cpp
    PhongLightingEffect.cpp
    PrimitiveIntersector.cpp
    Profile.cpp
    Profiler.cpp
    Progress.cpp
    Random.cpp
    Registry.cpp
    ResourceReleaser.cpp
    Revisioning.cpp
    SceneGraphCallback.cpp
    ScreenSpaceLayout.cpp
    ShaderFactory.cpp
    ShaderGenerator.cpp
    ShaderLoader.cpp
    ShaderUtils.cpp
    Shadowing.cpp
    SimplexNoise.cpp
    SpatialReference.cpp
    StateSetCache.cpp
    StateSetLOD.cpp
    Status.cpp
    StringUtils.cpp
    TaskService.cpp
    Terrain.cpp
    TerrainLayer.cpp
    TerrainOptions.cpp
    TerrainEngineNode.cpp
    TerrainResources.cpp
    TerrainTileModel.cpp
    TerrainTileModelFactory.cpp
    Tessellator.cpp
    TextureBufferSerializer.cpp
    TileKey.cpp
    TileHandler.cpp
    TileRasterizer.cpp
    TileVisitor.cpp
    TileSource.cpp
    TimeControl.cpp
    TraversalData.cpp
    ThreadingUtils.cpp
    Units.cpp
    URI.cpp
    Utils.cpp
    Version.cpp
    VerticalDatum.cpp
    VideoLayer.cpp
    Viewpoint.cpp
    VirtualProgram.cpp
    VisibleLayer.cpp
    XmlUtils.cpp
    ${SHADERS_CPP} )


ADD_LIBRARY(
    ${LIB_NAME} ${OSGEARTH_USER_DEFINED_DYNAMIC_OR_STATIC}
    ${LIB_PUBLIC_HEADERS}
    ${TINYXML_SRC}
    ${VERSION_GIT_SOURCE}
    ${TARGET_SRC}
    ${TARGET_GLSL}
    ${TARGET_IN} )

INCLUDE_DIRECTORIES(${GDAL_INCLUDE_DIR} ${CURL_INCLUDE_DIR} ${OSG_INCLUDE_DIR} )

IF (TINYXML_FOUND)
    INCLUDE_DIRECTORIES(${TINYXML_INCLUDE_DIR})
ENDIF (TINYXML_FOUND)

IF (WIN32)
  LINK_EXTERNAL(${LIB_NAME} ${TARGET_EXTERNAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY} )
ELSE(WIN32)
  LINK_EXTERNAL(${LIB_NAME} ${TARGET_EXTERNAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY} )
ENDIF(WIN32)

#LINK_WITH_VARIABLES(${LIB_NAME} OSG_LIBRARY OSGUTIL_LIBRARY OSGSIM_LIBRARY OSGTERRAIN_LIBRARY OSGDB_LIBRARY OSGFX_LIBRARY OSGVIEWER_LIBRARY OSGTEXT_LIBRARY OSGGA_LIBRARY OSGSHADOW_LIBRARY OPENTHREADS_LIBRARY CURL_LIBRARY GDAL_LIBRARY ZLIB_LIBRARY OSGMANIPULATOR_LIBRARY)

OPTION(NRL_STATIC_LIBRARIES "Link osgEarth against static GDAL and cURL, including static OpenSSL, Proj4, JPEG, PNG, and TIFF." OFF)
if(NOT NRL_STATIC_LIBRARIES)
  LINK_WITH_VARIABLES(${LIB_NAME} OSG_LIBRARY OSGUTIL_LIBRARY OSGSIM_LIBRARY OSGTERRAIN_LIBRARY OSGDB_LIBRARY OSGFX_LIBRARY OSGVIEWER_LIBRARY OSGTEXT_LIBRARY OSGGA_LIBRARY OSGSHADOW_LIBRARY OPENTHREADS_LIBRARY CURL_LIBRARY GDAL_LIBRARY ZLIB_LIBRARY OSGMANIPULATOR_LIBRARY)
else(NOT NRL_STATIC_LIBRARIES)
  LINK_WITH_VARIABLES(${LIB_NAME} OSG_LIBRARY OSGUTIL_LIBRARY OSGSIM_LIBRARY OSGTERRAIN_LIBRARY OSGDB_LIBRARY OSGFX_LIBRARY OSGVIEWER_LIBRARY OSGTEXT_LIBRARY OSGGA_LIBRARY OSGSHADOW_LIBRARY OPENTHREADS_LIBRARY CURL_LIBRARY GDAL_LIBRARY ZLIB_LIBRARY OSGMANIPULATOR_LIBRARY SSL_EAY_RELEASE LIB_EAY_RELEASE TIFF_LIBRARY PROJ4_LIBRARY PNG_LIBRARY JPEG_LIBRARY)
endif(NOT NRL_STATIC_LIBRARIES)

LINK_CORELIB_DEFAULT(${LIB_NAME} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY})

IF (TINYXML_FOUND)
    LINK_WITH_VARIABLES(${LIB_NAME} TINYXML_LIBRARY)
    get_directory_property(output INCLUDE_DIRECTORIES)
    message(STATUS ${output})
ENDIF (TINYXML_FOUND)

INCLUDE(ModuleInstall OPTIONAL)

=== src/osgEarthAnnotation/CMakeLists.txt ===
IF   (DYNAMIC_OSGEARTH)
    ADD_DEFINITIONS(-DOSGEARTHANNO_LIBRARY)
ELSE (DYNAMIC_OSGEARTH)
    ADD_DEFINITIONS(-DOSGEARTHANNO_LIBRARY_STATIC)
ENDIF(DYNAMIC_OSGEARTH)

set(LIB_NAME osgEarthAnnotation)

set(HEADER_PATH ${OSGEARTH_SOURCE_DIR}/include/${LIB_NAME})

set(LIB_PUBLIC_HEADERS
    AnnotationSettings
    AnnotationEditing
    AnnotationData
    AnnotationLayer
    AnnotationNode
    AnnotationRegistry
    AnnotationUtils
	BboxDrawable
    CircleNode
    Common
    Draggers
    EllipseNode
    Export
    FeatureNode
    FeatureEditing
    GeoPositionNode
    GeoPositionNodeAutoScaler
    LocalGeometryNode
    ImageOverlay
    ImageOverlayEditor
    LabelNode
    ModelNode
    PlaceNode
    RectangleNode
    TrackNode
)

set(LIB_COMMON_FILES
    AnnotationEditing.cpp
    AnnotationSettings.cpp
    AnnotationData.cpp
    AnnotationLayer.cpp
    AnnotationNode.cpp
    AnnotationRegistry.cpp
    AnnotationUtils.cpp
	BboxDrawable.cpp
    CircleNode.cpp
    Draggers.cpp
    EllipseNode.cpp
    FeatureNode.cpp
    FeatureEditing.cpp
    GeoPositionNode.cpp
    GeoPositionNodeAutoScaler.cpp
    LocalGeometryNode.cpp
    ImageOverlay.cpp
    ImageOverlayEditor.cpp
    LabelNode.cpp
    RectangleNode.cpp
    ModelNode.cpp
    PlaceNode.cpp
    TrackNode.cpp
)


ADD_LIBRARY( ${LIB_NAME} ${OSGEARTH_USER_DEFINED_DYNAMIC_OR_STATIC}
    ${LIB_PUBLIC_HEADERS}
    ${LIB_COMMON_FILES}
)



INCLUDE_DIRECTORIES(${OSG_INCLUDE_DIR} ${OSGEARTH_SOURCE_DIR} ${GDAL_INCLUDE_DIR})

IF (WIN32)
  LINK_EXTERNAL(${LIB_NAME} ${TARGET_EXTERNAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY})
ELSE(WIN32)
  LINK_EXTERNAL(${LIB_NAME} ${TARGET_EXTERNAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY})
ENDIF(WIN32)

LINK_INTERNAL(${LIB_NAME}
    osgEarth
    osgEarthFeatures
    osgEarthSymbology
)

LINK_WITH_VARIABLES(${LIB_NAME} OSG_LIBRARY OSGUTIL_LIBRARY OSGSIM_LIBRARY OSGTERRAIN_LIBRARY OSGDB_LIBRARY OSGFX_LIBRARY OSGMANIPULATOR_LIBRARY OSGVIEWER_LIBRARY OSGTEXT_LIBRARY OSGGA_LIBRARY OPENTHREADS_LIBRARY GDAL_LIBRARY)
LINK_CORELIB_DEFAULT(${LIB_NAME} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY})

INCLUDE(ModuleInstall OPTIONAL)

=== src/osgEarthDrivers/CMakeLists.txt ===
#---------------------------------------------------
# OSG CMAKE SUPPORT
# (C) by Michael Wagner, mtw@shared-reality.com 2005
# (C) Eric Wing, Luigi Calori and Robert Osfield 2006-2007
#---------------------------------------------------

PROJECT(OSGEARTH_PLUGINS_MASTER)

INCLUDE_DIRECTORIES(${OSG_INCLUDE_DIRS} )

SET(CMAKE_SHARED_MODULE_PREFIX ${OSGEARTH_PLUGIN_PREFIX})

IF(MSVC80)
  IF(NOT OSGEARTH_MSVC_GENERATE_PLUGINS_AND_WRAPPERS_MANIFESTS)
    SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} /MANIFEST:NO")
  ENDIF(NOT OSGEARTH_MSVC_GENERATE_PLUGINS_AND_WRAPPERS_MANIFESTS)
ENDIF(MSVC80)

SET(TARGET_DEFAULT_PREFIX "osgdb_")
SET(TARGET_DEFAULT_LABEL_PREFIX "Plugin")

#OpenThreads, osg, osgDB and osgUtil are included elsewhere.
SET(TARGET_COMMON_LIBRARIES
    osgEarth
)

# Folder name for plugins
SET(OSGEARTH_PLUGINS_FOLDER Plugins)

add_subdirectory(agglite)
add_subdirectory(arcgis)
add_subdirectory(bing)
add_subdirectory(bumpmap)
add_subdirectory(cache_filesystem)
add_subdirectory(cache_leveldb)
add_subdirectory(cache_rocksdb)
add_subdirectory(colorramp)
add_subdirectory(debug)
add_subdirectory(detail)
add_subdirectory(earth)
add_subdirectory(engine_mp)
add_subdirectory(engine_rex)
add_subdirectory(fastdxt)
add_subdirectory(featurefilter_intersect)
add_subdirectory(featurefilter_join)
add_subdirectory(feature_elevation)
add_subdirectory(feature_mapnikvectortiles)
add_subdirectory(feature_ogr)
add_subdirectory(feature_raster)
add_subdirectory(feature_tfs)
add_subdirectory(feature_wfs)
add_subdirectory(feature_xyz)
add_subdirectory(gdal)
add_subdirectory(kml)
add_subdirectory(label_annotation)
add_subdirectory(mapinspector)
add_subdirectory(mask_feature)
add_subdirectory(mbtiles)
add_subdirectory(model_feature_geom)
add_subdirectory(model_simple)
add_subdirectory(monitor)
add_subdirectory(ocean_simple)
add_subdirectory(ocean_triton)
add_subdirectory(osg)
add_subdirectory(script_engine_duktape)
add_subdirectory(skyview)
add_subdirectory(sky_gl)
add_subdirectory(sky_silverlining)
add_subdirectory(sky_simple)
add_subdirectory(template)
add_subdirectory(terrainshader)
add_subdirectory(tileindex)
add_subdirectory(tms)
add_subdirectory(vdatum_egm2008)
add_subdirectory(vdatum_egm84)
add_subdirectory(vdatum_egm96)
add_subdirectory(viewpoints)
add_subdirectory(vpb)
add_subdirectory(wcs)
add_subdirectory(wms)
add_subdirectory(xyz)

=== src/osgEarthFeatures/CMakeLists.txt ===
IF   (DYNAMIC_OSGEARTH)
    ADD_DEFINITIONS(-DOSGEARTHFEATURES_LIBRARY)
ELSE (DYNAMIC_OSGEARTH)
    ADD_DEFINITIONS(-DOSGEARTHFEATURES_LIBRARY_STATIC)
ENDIF(DYNAMIC_OSGEARTH)

IF (GEOS_FOUND)
    ADD_DEFINITIONS(-DOSGEARTH_HAVE_GEOS)
ENDIF(GEOS_FOUND)

SET(LIB_NAME osgEarthFeatures)

set(TARGET_GLSL
    GPULinesScreenProj.glsl)

set(SHADERS_CPP "${CMAKE_CURRENT_BINARY_DIR}/AutoGenShaders.cpp")

set(TARGET_IN
    Shaders.cpp.in)

configure_shaders(
    Shaders.cpp.in
    ${SHADERS_CPP}
    ${TARGET_GLSL} )

SET(HEADER_PATH ${OSGEARTH_SOURCE_DIR}/include/${LIB_NAME})
SET(LIB_PUBLIC_HEADERS
    AltitudeFilter
    BufferFilter
    BuildGeometryFilter  
    BuildTextFilter
    CentroidFilter
    Common
    ConvertTypeFilter
    CropFilter
    ExtrudeGeometryFilter    
    Feature
    FeatureCursor
    FeatureDisplayLayout
    FeatureIndex
    FeatureListSource
    FeatureMaskLayer
    FeatureModelGraph
    FeatureModelLayer
    FeatureModelSource
    FeatureSource
    FeatureSourceIndexNode
    FeatureSourceLayer
    FeatureTileSource
    Filter
    FilterContext
    GeometryCompiler
    GeometryUtils
    GPULines
    LabelSource
    MVT
    OgrUtils
    PolygonizeLines
    ResampleFilter
    ScaleFilter
    Session
    ScatterFilter
    Script
    ScriptEngine
    ScriptFilter
    Shaders
    SubstituteModelFilter
    TessellateOperator
    TextSymbolizer
    TransformFilter
    VirtualFeatureSource
)

SET(TARGET_SRC
    AltitudeFilter.cpp
    BufferFilter.cpp
    BuildGeometryFilter.cpp 
    BuildTextFilter.cpp
    CentroidFilter.cpp
    ConvertTypeFilter.cpp
    CropFilter.cpp
    ExtrudeGeometryFilter.cpp    
    Feature.cpp
    FeatureCursor.cpp
    FeatureDisplayLayout.cpp
    FeatureListSource.cpp
    FeatureMaskLayer.cpp
    FeatureModelGraph.cpp
    FeatureModelLayer.cpp
    FeatureModelSource.cpp
    FeatureSource.cpp
    FeatureSourceIndexNode.cpp
    FeatureSourceLayer.cpp
    FeatureTileSource.cpp
    Filter.cpp
    FilterContext.cpp
    GeometryCompiler.cpp
    GeometryUtils.cpp
    GPULines.cpp
    LabelSource.cpp
    MVT.cpp
    OgrUtils.cpp
    PolygonizeLines.cpp
    ResampleFilter.cpp
    ScaleFilter.cpp
    Session.cpp
    ScatterFilter.cpp
    ScriptEngine.cpp
    ScriptFilter.cpp
    SubstituteModelFilter.cpp
    TessellateOperator.cpp
    TextSymbolizer.cpp
    TransformFilter.cpp
    VirtualFeatureSource.cpp 
    ${SHADERS_CPP}
)

IF(PROTOBUF_FOUND AND PROTOBUF_PROTOC_EXECUTABLE)

  INCLUDE_DIRECTORIES(${PROTOBUF_INCLUDE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
  PROTOBUF_GENERATE_CPP(PROTO_VECTOR_TILE_CPP PROTO_VECTOR_TILE_H vector_tile.proto)

  SET(LIB_PUBLIC_HEADERS
    ${LIB_PUBLIC_HEADERS}
    ${PROTO_VECTOR_TILE_H}
  )

  SET(TARGET_SRC
    ${TARGET_SRC}
    ${PROTO_VECTOR_TILE_CPP}
  )

  ADD_DEFINITIONS(-DOSGEARTH_HAVE_MVT)

ENDIF()

ADD_LIBRARY(${LIB_NAME}
    ${OSGEARTH_USER_DEFINED_DYNAMIC_OR_STATIC}
    ${LIB_PUBLIC_HEADERS}
    ${TARGET_SRC}
    ${TARGET_GLSL}
    ${TARGET_IN}
)

INCLUDE_DIRECTORIES(${GDAL_INCLUDE_DIR})


IF (WIN32)
  LINK_EXTERNAL(${LIB_NAME} ${TARGET_EXTERNAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY})
ELSE(WIN32)
  LINK_EXTERNAL(${LIB_NAME} ${TARGET_EXTERNAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY})
ENDIF(WIN32)

LINK_INTERNAL(${LIB_NAME}
    osgEarth
    osgEarthSymbology
)

SET(LINK_VARS
    OSG_LIBRARY OSGUTIL_LIBRARY OSGSIM_LIBRARY OSGTERRAIN_LIBRARY OSGDB_LIBRARY OSGFX_LIBRARY
    OSGVIEWER_LIBRARY OSGTEXT_LIBRARY OSGGA_LIBRARY OPENTHREADS_LIBRARY)

IF(PROTOBUF_FOUND AND PROTOBUF_PROTOC_EXECUTABLE)
  list(APPEND LINK_VARS PROTOBUF_LIBRARIES)
ENDIF()

LINK_WITH_VARIABLES(${LIB_NAME} ${LINK_VARS})

LINK_CORELIB_DEFAULT(${LIB_NAME} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY})

INCLUDE(ModuleInstall OPTIONAL)

=== src/osgEarthQt/CMakeLists.txt ===

IF (Qt5Widgets_FOUND OR QT4_FOUND AND NOT ANDROID AND OSGEARTH_QT_BUILD)

    if(DYNAMIC_OSGEARTH)
        ADD_DEFINITIONS(-DOSGEARTHQT_LIBRARY)
    else(DYNAMIC_OSGEARTH)
        ADD_DEFINITIONS(-DOSGEARTHQT_LIBRARY_STATIC)
    endif(DYNAMIC_OSGEARTH)

    IF(Qt5Widgets_FOUND)
      SET(LIB_NAME osgEarthQt5)
      SET(HEADER_INSTALL_DIR osgEarthQt)
    ELSE(Qt5Widgets_FOUND)
      SET(LIB_NAME osgEarthQt)
    ENDIF(Qt5Widgets_FOUND)

    SET(HEADER_PATH ${OSGEARTH_SOURCE_DIR}/include/${LIB_NAME})

    if(OSGEARTH_QT_BUILD_LEGACY_WIDGETS)
        # Header files that need moc'd
        set(LIB_MOC_HDRS
            CollapsiblePairWidget
            DataManager
            LayerManagerWidget
            LOSControlWidget
            LOSCreationDialog
            MapCatalogWidget
            TerrainProfileGraph
            TerrainProfileWidget
            ViewerWidget
        )

        # Qt resource files
        set(LIB_QT_RCS
            images.qrc
        )

        # Qt UI files
        set(LIB_QT_UIS
            ui/LOSCreationDialog.ui
        )
    else(OSGEARTH_QT_BUILD_LEGACY_WIDGETS)
        # Header files that need moc'd
        set(LIB_MOC_HDRS
            ViewerWidget
        )
    endif(OSGEARTH_QT_BUILD_LEGACY_WIDGETS)

    IF(Qt5Widgets_FOUND)
        QT5_ADD_RESOURCES( LIB_RC_SRCS ${LIB_QT_RCS} )
        QT5_WRAP_UI( LIB_UI_HDRS ${LIB_QT_UIS} )
        QT5_WRAP_CPP( LIB_UI_SRCS ${LIB_UI_HDRS} )
        SET(LIB_MOC_SRCS)
        FOREACH( LIB_MOC_HDR ${LIB_MOC_HDRS} )
            GET_FILENAME_COMPONENT( LIB_MOC_HDR_ABS ${LIB_MOC_HDR} ABSOLUTE )
            QT5_WRAP_CPP( LIB_MOC_SRC ${LIB_MOC_HDR} OPTIONS "-f${LIB_MOC_HDR_ABS}" )
            LIST( APPEND LIB_MOC_SRCS ${LIB_MOC_SRC} )
        ENDFOREACH()
    ELSE()
        INCLUDE( ${QT_USE_FILE} )
        QT4_ADD_RESOURCES( LIB_RC_SRCS ${LIB_QT_RCS} )
        QT4_WRAP_UI( LIB_UI_HDRS ${LIB_QT_UIS} )
        QT4_WRAP_CPP( LIB_UI_SRCS ${LIB_UI_HDRS} OPTIONS "-f" )
        QT4_WRAP_CPP( LIB_MOC_SRCS ${LIB_MOC_HDRS} OPTIONS "-f" )
    ENDIF()

    if(OSGEARTH_QT_BUILD_LEGACY_WIDGETS)
        SET(LIB_PUBLIC_HEADERS
        #   header files go here
            Actions
            CollapsiblePairWidget
            Common
            DataManager
            GuiActions
            LayerManagerWidget
            LOSControlWidget
            LOSCreationDialog
            MapCatalogWidget
            TerrainProfileGraph
            TerrainProfileWidget
            ViewWidget
            ViewerWidget
            ${LIB_UI_HDRS}
            ${LIB_QT_UIS}
            ${LIB_QT_RCS}
        )

        ADD_LIBRARY(${LIB_NAME} ${OSGEARTH_USER_DEFINED_DYNAMIC_OR_STATIC}
            ${LIB_PUBLIC_HEADERS}
        #  .cpp files go here
            ${LIB_RC_SRCS}
            ${LIB_UI_SRCS}
            ${LIB_MOC_SRCS}
            CollapsiblePairWidget.cpp
            DataManager.cpp
            LayerManagerWidget.cpp
            LOSControlWidget.cpp
            LOSCreationDialog.cpp
            MapCatalogWidget.cpp
            TerrainProfileGraph.cpp
            TerrainProfileWidget.cpp
            ViewWidget.cpp
            ViewerWidget.cpp
        )
    else(OSGEARTH_QT_BUILD_LEGACY_WIDGETS)
        SET(LIB_PUBLIC_HEADERS
        #   header files go here
            Common
            ViewWidget
            ViewerWidget
            ${LIB_UI_HDRS}
            ${LIB_QT_UIS}
            ${LIB_QT_RCS}
        )

        ADD_LIBRARY(${LIB_NAME} ${OSGEARTH_USER_DEFINED_DYNAMIC_OR_STATIC}
            ${LIB_PUBLIC_HEADERS}
        #  .cpp files go here
            ${LIB_RC_SRCS}
            ${LIB_UI_SRCS}
            ${LIB_MOC_SRCS}
            ViewWidget.cpp
            ViewerWidget.cpp
        )
    endif(OSGEARTH_QT_BUILD_LEGACY_WIDGETS)

    INCLUDE_DIRECTORIES(${OSG_INCLUDE_DIR} ${OSGEARTH_SOURCE_DIR} ${QT_INCLUDES} ${CMAKE_CURRENT_BINARY_DIR})

    IF (WIN32)
      LINK_EXTERNAL(${LIB_NAME} ${TARGET_EXTERNAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY})
    ELSE(WIN32)
      LINK_EXTERNAL(${LIB_NAME} ${TARGET_EXTERNAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY})
    ENDIF(WIN32)

    if(OSGEARTH_QT_BUILD_LEGACY_WIDGETS)
        link_internal(${LIB_NAME}
            osgEarth
            osgEarthAnnotation
            osgEarthUtil
            ${QT_QTCORE_LIBRARY}
            ${QT_QTGUI_LIBRARY}
            ${QT_QTOPENGL_LIBRARY}
            ${QT_QTOPENGLEXTENSIONS_LIBRARY}
        )
    else(OSGEARTH_QT_BUILD_LEGACY_WIDGETS)
        link_internal(${LIB_NAME}
            osgEarth
            osgEarthUtil
            ${QT_QTCORE_LIBRARY}
            ${QT_QTGUI_LIBRARY}
            ${QT_QTOPENGL_LIBRARY}
            ${QT_QTOPENGLEXTENSIONS_LIBRARY}
        )
    endif(OSGEARTH_QT_BUILD_LEGACY_WIDGETS)

    LINK_WITH_VARIABLES(${LIB_NAME} OSG_LIBRARY OSGWIDGET_LIBRARY OSGUTIL_LIBRARY OSGSIM_LIBRARY OSGTERRAIN_LIBRARY OSGDB_LIBRARY OSGFX_LIBRARY OSGVIEWER_LIBRARY OSGTEXT_LIBRARY OSGGA_LIBRARY OSGQT_LIBRARY OPENTHREADS_LIBRARY)

    LINK_CORELIB_DEFAULT(${LIB_NAME} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY})

    IF ( Qt5Widgets_FOUND )
        qt5_use_modules( ${LIB_NAME} Gui Widgets OpenGL )
    ENDIF( Qt5Widgets_FOUND )

    # Add this project to the NodeKits solution folder
    set_property( TARGET ${LIB_NAME} PROPERTY FOLDER "NodeKits" )

    INCLUDE(ModuleInstall OPTIONAL)

ENDIF (Qt5Widgets_FOUND OR QT4_FOUND AND NOT ANDROID AND OSGEARTH_QT_BUILD)

=== src/osgEarthSilverLining/CMakeLists.txt ===
IF(SILVERLINING_FOUND)

IF   (DYNAMIC_OSGEARTH)
    ADD_DEFINITIONS(-DOSGEARTHSILVERLINING_LIBRARY)
ELSE (DYNAMIC_OSGEARTH)
    ADD_DEFINITIONS(-DOSGEARTHSILVERLINING_LIBRARY_STATIC)
ENDIF(DYNAMIC_OSGEARTH)

SET(LIB_NAME osgEarthSilverLining)

SET(HEADER_PATH ${OSGEARTH_SOURCE_DIR}/include/${LIB_NAME})

SET(LIB_PUBLIC_HEADERS
#   header files go here
    Common
    Export
    SilverLiningOptions
    SilverLiningNode
    SilverLiningContext
    SilverLiningSkyDrawable
    SilverLiningCloudsDrawable
    SilverLiningAPIWrapper
    SilverLiningCallback
	SilverLiningContextNode
)

ADD_LIBRARY(${LIB_NAME} ${OSGEARTH_USER_DEFINED_DYNAMIC_OR_STATIC}
    ${LIB_PUBLIC_HEADERS}
#  .cpp files go here
    SilverLiningNode.cpp
    SilverLiningContext.cpp
    SilverLiningSkyDrawable.cpp
    SilverLiningCloudsDrawable.cpp
    SilverLiningAPIWrapper.cpp
	SilverLiningContextNode.cpp
)

INCLUDE_DIRECTORIES( 
    ${OSG_INCLUDE_DIR}
    ${OSGEARTH_SOURCE_DIR}
    ${SILVERLINING_INCLUDE_DIR}
)

LINK_EXTERNAL(
	${LIB_NAME}
	${TARGET_EXTERNAL_LIBRARIES}
	${CMAKE_THREAD_LIBS_INIT} )

LINK_INTERNAL(
    ${LIB_NAME}
    osgEarth
    osgEarthUtil
)

LINK_WITH_VARIABLES(
	${LIB_NAME} 
	OSG_LIBRARY
	OSGDB_LIBRARY
	OPENTHREADS_LIBRARY
    SILVERLINING_LIBRARY)

LINK_CORELIB_DEFAULT(
	${LIB_NAME}
	${CMAKE_THREAD_LIBS_INIT} )

# Add this project to the NodeKits solution folder
set_property( TARGET ${LIB_NAME} PROPERTY FOLDER "NodeKits" )

INCLUDE(ModuleInstall OPTIONAL)

ENDIF(SILVERLINING_FOUND)

=== src/osgEarthSymbology/CMakeLists.txt ===
IF   (DYNAMIC_OSGEARTH)
    ADD_DEFINITIONS(-DOSGEARTHSYMBOLOGY_LIBRARY)
ELSE (DYNAMIC_OSGEARTH)
    ADD_DEFINITIONS(-DOSGEARTHSYMBOLOGY_LIBRARY_STATIC)
ENDIF(DYNAMIC_OSGEARTH)

IF (GEOS_FOUND)
    ADD_DEFINITIONS(-DOSGEARTH_HAVE_GEOS)
ENDIF(GEOS_FOUND)

SET(LIB_NAME osgEarthSymbology)

SET(HEADER_PATH ${OSGEARTH_SOURCE_DIR}/include/${LIB_NAME})
SET(LIB_PUBLIC_HEADERS
#   header files go here
    AGG.h
    AltitudeSymbol
    BBoxSymbol
    BillboardResource
    BillboardSymbol
    Common
    Color
    CoverageSymbol
    CssUtils
    Expression
    ExtrusionSymbol
    Fill
    Geometry
    GeometryFactory
    GEOS
    GeometryRasterizer
    IconResource
    IconSymbol
    InstanceResource
    InstanceSymbol
    LineSymbol
    MarkerResource
    MarkerSymbol
    MeshConsolidator
    MeshFlattener
    MeshSubdivider
    ModelResource
    ModelSymbol
    PointSymbol
    PolygonSymbol
    Query
    RenderSymbol
    Resource
    ResourceCache
    ResourceLibrary
    Skins
    StencilVolumeNode
    Stroke
    Style
    StyleSelector
    StyleSheet
    Symbol
    Tags
    TextSymbol
)

ADD_LIBRARY(${LIB_NAME} ${OSGEARTH_USER_DEFINED_DYNAMIC_OR_STATIC}
    ${LIB_PUBLIC_HEADERS}
#  .cpp files go here
    AltitudeSymbol.cpp
    BBoxSymbol.cpp
    BillboardResource.cpp
    BillboardSymbol.cpp
    Color.cpp
    CoverageSymbol.cpp
    CssUtils.cpp
    Expression.cpp
    ExtrusionSymbol.cpp
    Fill.cpp
    Geometry.cpp
    GeometryFactory.cpp
    GEOS.cpp
    GeometryRasterizer.cpp
    IconResource.cpp
    IconSymbol.cpp
    InstanceResource.cpp
    InstanceSymbol.cpp
    LineSymbol.cpp
    MarkerResource.cpp
    MarkerSymbol.cpp
    MeshConsolidator.cpp
    MeshFlattener.cpp
    MeshSubdivider.cpp
    ModelResource.cpp
    ModelSymbol.cpp
    PointSymbol.cpp
    PolygonSymbol.cpp
    Query.cpp
    RenderSymbol.cpp
    Resource.cpp
    ResourceCache.cpp
    ResourceLibrary.cpp
    Skins.cpp
    StencilVolumeNode.cpp
    Stroke.cpp
    Style.cpp
    StyleSelector.cpp
    StyleSheet.cpp
    Symbol.cpp
    TextSymbol.cpp
)

IF(GEOS_FOUND)
  INCLUDE_DIRECTORIES(${OSG_INCLUDE_DIR} ${OSGEARTH_SOURCE_DIR} ${GEOS_INCLUDE_DIR})
ELSE(GEOS_FOUND)
  INCLUDE_DIRECTORIES(${OSG_INCLUDE_DIR} ${OSGEARTH_SOURCE_DIR})
ENDIF(GEOS_FOUND)

IF (WIN32)
  LINK_EXTERNAL(${LIB_NAME} ${TARGET_EXTERNAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY})
ELSE(WIN32)
  LINK_EXTERNAL(${LIB_NAME} ${TARGET_EXTERNAL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY})
ENDIF(WIN32)

LINK_INTERNAL(${LIB_NAME}
    osgEarth
)

IF(GEOS_FOUND)
   LINK_WITH_VARIABLES(${LIB_NAME} OSG_LIBRARY OSGWIDGET_LIBRARY OSGUTIL_LIBRARY OSGSIM_LIBRARY OSGTERRAIN_LIBRARY OSGDB_LIBRARY OSGFX_LIBRARY OSGVIEWER_LIBRARY OSGTEXT_LIBRARY OSGGA_LIBRARY OPENTHREADS_LIBRARY GEOS_LIBRARY)
ELSE(GEOS_FOUND)
  LINK_WITH_VARIABLES(${LIB_NAME} OSG_LIBRARY OSGWIDGET_LIBRARY OSGUTIL_LIBRARY OSGSIM_LIBRARY OSGTERRAIN_LIBRARY OSGDB_LIBRARY OSGFX_LIBRARY OSGVIEWER_LIBRARY OSGTEXT_LIBRARY OSGGA_LIBRARY OPENTHREADS_LIBRARY)
ENDIF(GEOS_FOUND)

LINK_CORELIB_DEFAULT(${LIB_NAME} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBRARY})

INCLUDE(ModuleInstall OPTIONAL)

=== debian/changelog ===
osgearth (2.9.0+dfsg-3) unstable; urgency=medium

  * Drop autopkgtest to test installability.
  * Add lintian override for testsuite-autopkgtest-missing.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 01 Aug 2018 08:55:54 +0200

osgearth (2.9.0+dfsg-2) unstable; urgency=medium

  * Update Vcs-* URLs for Salsa.
  * Bump Standards-Version to 4.1.5, no changes.
  * Drop obsolete get-orig-source target.
  * Strip trailing whitespace from control & rules files.
  * Remove documentation outside usr/share/doc.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 20 Jul 2018 22:53:12 +0200

=== debian/control ===
Source: osgearth
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Pirmin Kalberer <pi_deb@sourcepole.ch>,
           Bas Couwenberg <sebastic@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.16.1.1),
               cmake,
               openscenegraph-3.4,
               libopenscenegraph-3.4-dev,
               libcurl4-gnutls-dev | libcurl-ssl-dev,
               libgdal-dev (>= 1.10.1~),
               libgeos-dev,
               libexpat1-dev,
               libnoise-dev,
               libprotobuf-dev,
               libqt5opengl5-dev,
               libsqlite3-dev,
               protobuf-compiler,
               qtbase5-dev,
               zlib1g-dev,
               pkg-kde-tools,
               docbook2x,
               docbook-xsl,
               docbook-xml,
               xsltproc
Standards-Version: 4.1.5
Vcs-Browser: https://salsa.debian.org/debian-gis-team/osgearth
Vcs-Git: https://salsa.debian.org/debian-gis-team/osgearth.git
Homepage: http://osgearth.org/

Package: osgearth
Architecture: any
Depends: fonts-liberation,
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: osgearth-data
Description: Dynamic 3D terrain rendering toolkit for OpenSceneGraph (binaries)
 osgEarth is a scalable terrain rendering toolkit for OpenSceneGraph
 (OSG), an open source, high performance, 3D graphics toolkit. Just create a
 simple XML file, point it at your imagery, elevation, and vector data, load it
 into your favorite OSG application, and go! osgEarth supports all kinds of
 data and comes with lots of examples to help you get up and running quickly
 and easily.
 .
 This package contains binaries.

Package: osgearth-data
Architecture: all
Depends: ${misc:Depends}
Description: Dynamic 3D terrain rendering toolkit for OpenSceneGraph (data)
 osgEarth is a scalable terrain rendering toolkit for OpenSceneGraph
 (OSG), an open source, high performance, 3D graphics toolkit. Just create a
 simple XML file, point it at your imagery, elevation, and vector data, load it
 into your favorite OSG application, and go! osgEarth supports all kinds of
 data and comes with lots of examples to help you get up and running quickly
 and easily.
 .
 This package contains data files.

Package: libosgearth5
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: openscenegraph-3.4
Breaks: libosgearth1 (<< 2.4.0+dfsg-4~),
        osgearth (<< 1.4-2)
Replaces: libosgearth1 (<< 2.4.0+dfsg-4~),
          osgearth (<< 1.4-2)
Description: Dynamic 3D terrain rendering toolkit for OpenSceneGraph (shared lib)
 osgEarth is a scalable terrain rendering toolkit for OpenSceneGraph
 (OSG), an open source, high performance, 3D graphics toolkit. Just create a
 simple XML file, point it at your imagery, elevation, and vector data, load it
 into your favorite OSG application, and go! osgEarth supports all kinds of
 data and comes with lots of examples to help you get up and running quickly
 and easily.
 .
 This package contains the shared library libosgEarth.

Package: libosgearthannotation5
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: openscenegraph-3.4
Description: Dynamic 3D terrain rendering toolkit for OpenSceneGraph (osgEarthAnnotation)
 osgEarth is a scalable terrain rendering toolkit for OpenSceneGraph
 (OSG), an open source, high performance, 3D graphics toolkit. Just create a
 simple XML file, point it at your imagery, elevation, and vector data, load it
 into your favorite OSG application, and go! osgEarth supports all kinds of
 data and comes with lots of examples to help you get up and running quickly
 and easily.
 .
 This package contains the shared library libosgEarthAnnotation.

Package: libosgearthfeatures5
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: openscenegraph-3.4
Description: Dynamic 3D terrain rendering toolkit for OpenSceneGraph (osgEarthFeatures)
 osgEarth is a scalable terrain rendering toolkit for OpenSceneGraph
 (OSG), an open source, high performance, 3D graphics toolkit. Just create a
 simple XML file, point it at your imagery, elevation, and vector data, load it
 into your favorite OSG application, and go! osgEarth supports all kinds of
 data and comes with lots of examples to help you get up and running quickly
 and easily.
 .
 This package contains the shared library libosgEarthFeatures.

Package: libosgearthqt5-5
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: openscenegraph-3.4
Description: Dynamic 3D terrain rendering toolkit for OpenSceneGraph (osgEarthQt)
 osgEarth is a scalable terrain rendering toolkit for OpenSceneGraph
 (OSG), an open source, high performance, 3D graphics toolkit. Just create a
 simple XML file, point it at your imagery, elevation, and vector data, load it
 into your favorite OSG application, and go! osgEarth supports all kinds of
 data and comes with lots of examples to help you get up and running quickly
 and easily.
 .
 This package contains the shared library libosgEarthQt.

Package: libosgearthsplat5
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: openscenegraph-3.4
Description: Dynamic 3D terrain rendering toolkit for OpenSceneGraph (osgEarthSplat)
 osgEarth is a scalable terrain rendering toolkit for OpenSceneGraph
 (OSG), an open source, high performance, 3D graphics toolkit. Just create a
 simple XML file, point it at your imagery, elevation, and vector data, load it
 into your favorite OSG application, and go! osgEarth supports all kinds of
 data and comes with lots of examples to help you get up and running quickly
 and easily.
 .
 This package contains the shared library libosgEarthSplat.

Package: libosgearthsymbology5
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: openscenegraph-3.4
Description: Dynamic 3D terrain rendering toolkit for OpenSceneGraph (osgEarthSymbology)
 osgEarth is a scalable terrain rendering toolkit for OpenSceneGraph
 (OSG), an open source, high performance, 3D graphics toolkit. Just create a
 simple XML file, point it at your imagery, elevation, and vector data, load it
 into your favorite OSG application, and go! osgEarth supports all kinds of
 data and comes with lots of examples to help you get up and running quickly
 and easily.
 .
 This package contains the shared library libosgEarthSymbology.

Package: libosgearthutil5
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: openscenegraph-3.4
Description: Dynamic 3D terrain rendering toolkit for OpenSceneGraph (osgEarthUtil)
 osgEarth is a scalable terrain rendering toolkit for OpenSceneGraph
 (OSG), an open source, high performance, 3D graphics toolkit. Just create a
 simple XML file, point it at your imagery, elevation, and vector data, load it
 into your favorite OSG application, and go! osgEarth supports all kinds of
 data and comes with lots of examples to help you get up and running quickly
 and easily.
 .
 This package contains the shared library libosgEarthUtil.

Package: openscenegraph-plugin-osgearth
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: OpenSceneGraph plugins for osgEarth
 osgEarth is a scalable terrain rendering toolkit for OpenSceneGraph
 (OSG), an open source, high performance, 3D graphics toolkit. Just create a
 simple XML file, point it at your imagery, elevation, and vector data, load it
 into your favorite OSG application, and go! osgEarth supports all kinds of
 data and comes with lots of examples to help you get up and running quickly
 and easily.
 .
 This package contains the OpenSceneGraph plugins.

Package: libosgearth-dev
Architecture: any
Section: libdevel
Depends: libosgearth5 (= ${binary:Version}),
         libosgearthannotation5 (= ${binary:Version}),
         libosgearthfeatures5 (= ${binary:Version}),
         libosgearthqt5-5 (= ${binary:Version}),
         libosgearthsplat5 (= ${binary:Version}),
         libosgearthsymbology5 (= ${binary:Version}),
         libosgearthutil5 (= ${binary:Version}),
         libopenscenegraph-3.4-dev,
         libgeos-dev,
         ${misc:Depends}
Replaces: osgearth-dev
Description: osgEarth development files
 osgEarth is a scalable terrain rendering toolkit for OpenSceneGraph
 (OSG), an open source, high performance, 3D graphics toolkit. Just create a
 simple XML file, point it at your imagery, elevation, and vector data, load it
 into your favorite OSG application, and go! osgEarth supports all kinds of
 data and comes with lots of examples to help you get up and running quickly
 and easily.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# CMake doesn't use hardening build flags set in CPPFLAGS
CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

include /usr/share/dpkg/pkg-info.mk

UPSTREAM_VERSION := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

BUILD_DATE := $(shell LC_ALL=C date -u "+%d %B %Y" -d "@$(SOURCE_DATE_EPOCH)")

MANPAGES:=$(wildcard debian/man/*.*.xml)

%:
	dh $@ --with pkgkde_symbolshelper \
	      --parallel

override_dh_clean:
	dh_clean debian/man/*.1
	-$(RM) -rf build/

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build -- \
		-DBUILD_OSGEARTH_EXAMPLES=0 \
		-DCMAKE_VERBOSE_MAKEFILE=1 \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DDEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH) \
		-DLIB_POSTFIX="" \
		-DOSG_DIR=/usr \
		-DOSGEARTH_QT_BUILD=1

override_dh_auto_build:
	# Create man pages from DocBook XML
	for x in $(MANPAGES) ; do \
	  docbook2x-man --string-param header-3="$(BUILD_DATE)" $$x ; \
	  mv `basename $$x | sed 's/.xml$$//'` `dirname $$x` ; \
	done

	dh_auto_build --builddirectory=build

override_dh_auto_install:
	dh_auto_install --builddirectory=build

	mkdir -p debian/osgearth-data/usr/share/osgearth/maps && \
	  cp tests/*.earth debian/osgearth-data/usr/share/osgearth/maps/ && \
	  cp debian/*.earth debian/osgearth-data/usr/share/osgearth/maps/ && \
	  sed --in-place -e 's!\\!/!g' -e 's!\.\./data!/usr/share/osgearth/data!g' debian/osgearth-data/usr/share/osgearth/maps/*.earth

	mkdir -p debian/osgearth-data/usr/share/osgearth/data && \
	  cp data/world.tif debian/osgearth-data/usr/share/osgearth/data/ && \
	  cp -r data/resources/ debian/osgearth-data/usr/share/osgearth/data/

	# Don't install binaries which depend on removed data files
	$(RM) debian/*/usr/bin/osgearth_3pv
	$(RM) debian/*/usr/bin/osgEarth_tests

override_dh_install:
	dh_install --autodest --list-missing

	$(RM) debian/*/usr/share/osgearth/data/resources/README.txt

override_dh_installchangelogs:
	dh_installchangelogs docs/source/releasenotes.rst

override_dh_shlibdeps:
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH):build/lib dh_shlibdeps

override_dh_makeshlibs:
	dh_makeshlibs -- -c0 -v$(UPSTREAM_VERSION)
